// C Source File
// Created 7/19/2002; 10:34:54 PM

// By Samuel Stearley copyright 2002
// sstear70@calvin.edu
// www.calvin.edu/~sstear70/




#define USE_TI89              // Produce .89z File
#define USE_TI92PLUS          // Produce .9xz File
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#define SAVE_SCREEN           // Save/Restore LCD Contents
#define NO_AMS_CHECK
#define NO_CALC_DETECT
#include <tigcclib.h>         // Include All Header Files




const	char keys[] = "F1\0F2\0F3\0F4\0F5\0001\00\0002\00\0003\00\0004\00\0005\00\0006\00\0007\00\0008\0";

inline char *IntToStr (int an_integer)
{
  static char result [] = "          \0";    // 10 spaces and \0
  char *ptr = result + 10;
  do {
      *ptr-- = an_integer % 10 + '0';
      an_integer/=10;
    } while (an_integer);
  return ptr+1;
}

//this will draw a string and clip the right edge from
//going over the screen edge.
void DoodleString(int x, int y,char * string)
{
	int xMax = ScrRect->xy.x1;
	char c;
	while ( (c = *(string++))){
		DrawClipChar(x,y,c,ScrRect,A_NORMAL);
		x += FontCharWidth(c);
		if (x > xMax) break;
	}
}


void _main(void)
{
	int * buffer = alloca(200);		//for a stack of page numbers.
	int * errorBuffer = alloca(200);
	int	pages = 0;
	int erNum = 10;	//initial good error number
	for (;;){
		clrscr();
		FontSetSys(0);
		*buffer = erNum;
		int * erBuf = errorBuffer;
		memset(erBuf,0,200);
		char * keyPresses = keys;
		int cord = 0;
		int success = 0;
		int i;
		for (i = 0;i<13;i++){
			*erBuf = erNum;
			erBuf++;
			DoodleString(0,cord,keyPresses);
			DoodleString(11,cord,IntToStr(erNum));
			char * erMsg = find_error_message(erNum);
			DoodleString(32,cord,erMsg);
			cord += 7;
			keyPresses += 3;
			//now find the next message, it will try 3000 possible messages and if
			//if it fails it gives up
			int j;
			success = 0;
			for (j=0;j<3000;j++){
				if (erMsg != find_error_message(++erNum)){
					success = 1;
					break;
				}
			}
			if (!success) break;
		}
		for (;;){
			int key	= ngetchx();
			if (key == KEY_ESC) return;
			else if (key == KEY_APPS){
				clrscr();
				DoodleString(20,20,"TiErrors By Samuel Stearley");
				DoodleString(20,27,"Copyright 2002");
				DoodleString(20,41,"sstear70@calvin.edu");
				DoodleString(20,48,"www.calvin.edu/~sstear70/");
				ngetchx();
				erNum = *buffer;
				break;
			}
			else if ( (success) && (key == KEY_DOWN) && (pages < 25)){
				buffer++;
				pages++;
				break;
			}
			else if ((key == KEY_UP) && (pages)){
				buffer--;
				erNum = *buffer;
				pages--;
				break;
			}
			else if ( (key >= KEY_F1) && (key <= KEY_F5)){
				int e = errorBuffer[key-KEY_F1];
				if (e) ERD_process(e);
			}
			else if ( (key >= '1') && (key <= '8')){
				int e = errorBuffer[5+key-'1'];
				if (e) ERD_process(e);
			}
		}
	}
}
